Subject: [quicwg/base-drafts] 23018d: Initial cut at packet number encryption

From: Martin Thomson <[email-masked]>
Date: Wed, 02 May 2018 21:25:57 -0700

Branch: refs/heads/master
  Home:   https://github.com/quicwg/base-drafts
  Commit: 23018df88dccf39f1af4ebdfa3c8bbed02354769
      https://github.com/quicwg/base-drafts/commit/23018df88dccf39f1af4ebdfa3c8bbed02354769
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Initial cut at packet number encryption

This is a little rough, but I think that the bones are here.

I know that we discussed removing short packet types in favor of putting the
lengths under encryption.  I will do that separately, just to keep the size of
this changeset to something more manageable.

  Commit: 41196efd08bd194cba92678ec06cc8bc06914965
      https://github.com/quicwg/base-drafts/commit/41196efd08bd194cba92678ec06cc8bc06914965
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Constant time

This is pretty onerous, so I'd like to see if people think that this is
acceptable.  The cost is that all packets need to have their AEAD run the whole
way through.  The gain is that there will be no side-channels for attackers to exploit.

  Commit: 1d6b9793138a03b0ec93bd86199c375a5179403b
      https://github.com/quicwg/base-drafts/commit/1d6b9793138a03b0ec93bd86199c375a5179403b
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  That was a little unclear on a re-read

  Commit: 16b663ae1bdef3bcd8ac90c967b3cac7ebded4f8
      https://github.com/quicwg/base-drafts/commit/16b663ae1bdef3bcd8ac90c967b3cac7ebded4f8
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  That was a little unclear on a re-read, again

  Commit: 1ea1ae5bf6d2784399805ee9a397bbbecc9eb645
      https://github.com/quicwg/base-drafts/commit/1ea1ae5bf6d2784399805ee9a397bbbecc9eb645
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  More tweaking (I have to stop this)

  Commit: 232572553a97191ddf55f025486b0051c5598491
      https://github.com/quicwg/base-drafts/commit/232572553a97191ddf55f025486b0051c5598491
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Some fairly obvious errors

  Commit: 86f262d5ea72c250d2806b8145e8b2d6a4d3f207
      https://github.com/quicwg/base-drafts/commit/86f262d5ea72c250d2806b8145e8b2d6a4d3f207
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Don't mess with ChaCha20, use it directly

  Commit: 1aec4b0936d3e30964eaeb05a17218fee76585c7
      https://github.com/quicwg/base-drafts/commit/1aec4b0936d3e30964eaeb05a17218fee76585c7
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Fix off-by-one error

  Commit: a5a6df0d111aba0dbd395e21c3b6421c425c57c7
      https://github.com/quicwg/base-drafts/commit/a5a6df0d111aba0dbd395e21c3b6421c425c57c7
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Two *different* packet numbers

  Commit: e641b72665393e49fa3d1d9a7292914c74fda09b
      https://github.com/quicwg/base-drafts/commit/e641b72665393e49fa3d1d9a7292914c74fda09b
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Remove repetition

  Commit: 379102013dda2655eb7b68304c7892794dc51996
      https://github.com/quicwg/base-drafts/commit/379102013dda2655eb7b68304c7892794dc51996
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Take and rework suggestions by @cwood

  Commit: 0f3c970169c9a2c20e7b61509f979f731d303f7c
      https://github.com/quicwg/base-drafts/commit/0f3c970169c9a2c20e7b61509f979f731d303f7c
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Just use AES-CTR

  Commit: 0c54fbf0e1cbcb5d094d86fe649273f7ae5d8d45
      https://github.com/quicwg/base-drafts/commit/0c54fbf0e1cbcb5d094d86fe649273f7ae5d8d45
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Make the order of operations clearer.

  Commit: f163e2ab2fbd7064a01e76a06b999f80a11b5c9b
      https://github.com/quicwg/base-drafts/commit/f163e2ab2fbd7064a01e76a06b999f80a11b5c9b
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Revert unnecessary change

  Commit: d6d9837d685d3de4d035a78fa7c99bc03e99e8ba
      https://github.com/quicwg/base-drafts/commit/d6d9837d685d3de4d035a78fa7c99bc03e99e8ba
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Restore some of the endpoint-agnosticism that got lost in rebasing

  Commit: a1c4d41f7110eedb5536bab02b1d927cc01b68c8
      https://github.com/quicwg/base-drafts/commit/a1c4d41f7110eedb5536bab02b1d927cc01b68c8
  Author: Martin Thomson <[email-masked]>
  Date:   2018-04-25 (Wed, 25 Apr 2018)

  Changed paths:
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Grammar boobo

  Commit: 8e7540f9ace4075ad0a3886944779b6ad8039958
      https://github.com/quicwg/base-drafts/commit/8e7540f9ace4075ad0a3886944779b6ad8039958
  Author: Martin Thomson <[email-masked]>
  Date:   2018-05-03 (Thu, 03 May 2018)

  Changed paths:
    M draft-ietf-quic-tls.md
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Addressing nits from final review

  Commit: 947db7f42e392d3db77d6ee68ef7f4c0d74a6247
      https://github.com/quicwg/base-drafts/commit/947db7f42e392d3db77d6ee68ef7f4c0d74a6247
  Author: Martin Thomson <[email-masked]>
  Date:   2018-05-03 (Thu, 03 May 2018)

  Changed paths:
    M draft-ietf-quic-tls.md

  Log Message:
  -----------
  Remove confusion without changing the design

  Commit: f4b52838e0d96675707f2756a8b9ba0ea1e9a579
      https://github.com/quicwg/base-drafts/commit/f4b52838e0d96675707f2756a8b9ba0ea1e9a579
  Author: Martin Thomson <[email-masked]>
  Date:   2018-05-03 (Thu, 03 May 2018)

  Changed paths:
    M draft-ietf-quic-tls.md
    M draft-ietf-quic-transport.md

  Log Message:
  -----------
  Merge pull request #1079 from quicwg/pn-encrypt

Packet number encryption

Compare: https://github.com/quicwg/base-drafts/compare/b7855fdb571f...f4b52838e0d9
      **NOTE:** This service been marked for deprecation: https://developer.github.com/changes/2018-04-25-github-services-deprecation/

      Functionality will be removed from GitHub.com on January 31st, 2019.